<template>
  <v-card>
    <v-form ref="form" lazy-validation>
      <v-container fluid>
        <v-layout wrap>
          <v-flex>
            <h2>Orders search</h2>
          </v-flex>
        </v-layout>
        <v-layout wrap>
          <v-flex xs12 md2>
            <v-menu
              :close-on-content-click="false"
              full-width
              lazy
              min-width="290px"
              :nudge-right="40"
              offset-y
              ref="datepicker"
              :return-value.sync="date"
              transition="scale-transition"
              v-model="datepicker"
            >
              <v-text-field
                clearable
                hint="MM/DD/YYYY format"
                label="Date"
                persistent-hint
                prepend-icon="event"
                slot="activator"
                v-model="dateFormatted"
              ></v-text-field>
              <v-date-picker
                @input="$refs.datepicker.save(date)"
                first-day-of-week="0"
                :locale="locale"
                :show-current="date"
                v-model="date"
              ></v-date-picker>

            </v-menu>
          </v-flex>
          <v-flex xs12 offset-md1 md2>
            <v-select
              clearable
              :items="statusList"
              item-value="text"
              label="Status"
              prepend-icon="departure_board"
              v-model="status"
            ></v-select>
          </v-flex>
          <v-flex xs12 offset-md1 md3>
            <v-text-field
              clearable
              label="Search text"
              prepend-icon="find_in_page"
              v-model="searchText"
            ></v-text-field>
          </v-flex>
          <v-flex xs12 offset-md1 md2>
            <v-btn color="primary" @click="submit"><v-icon left>search</v-icon>Search</v-btn>
            <v-btn @click="clear">Reset</v-btn>
          </v-flex>
        </v-layout>
      </v-container>
    </v-form>
  </v-card>
</template>

<script>
export default {
  name: 'SearchForm',
  data: () => ({
    date: null,
    datepicker: false,
    locale: 'en-US',
    searchText: null,
    status: null,
    statusList: [
      'delivered',
      'error',
      'pending',
      'shipped'
    ]
  }),
  computed: {
    // Getter and Setter needed due to nature of v-date-picker
    dateFormatted: {
      get: function () {
        return this.formatDate(this.date)
      },
      set: function (value) {
        this.date = this.parseDate(value)
      }
    },
    dateForAPI () {
      if (!this.date) return null

      const [year, month, day] = this.date.split('-')
      // API doesn't use leading zeros on DD/MM:
      return `${month.replace(/^0+/, '')}/${day.replace(/^0+/, '')}/${year}`
    }
  },
  methods: {
    // Form methods:
    submit () {
      // Send form's search values to parent component, there they'll be captured by the event and used to filter results
      this.$emit('formSearch', { dateForAPI: this.dateForAPI, status: this.status, searchText: this.searchText })
    },
    clear () {
      this.$refs.form.reset()
    },
    // Due to v-date-picker date format, this two functions are needed to translate formats:
    formatDate (date) {
      if (!date) return null

      const [year, month, day] = date.split('-')
      return `${month}/${day}/${year}`
    },
    parseDate (date) {
      if (!date) return null

      const [month, day, year] = date.split('/')
      return `${year}-${month.padStart(2, '0')}-${day.padStart(2, '0')}`
    }
  }
}
</script>
